/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;


static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperandsVec;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;


#line 148 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_PARAMETER = 13,       /* DIRECTIVE_PARAMETER  */
  YYSYMBOL_DIRECTIVE_VERSION = 14,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 15,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 16,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 17,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 18,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 19,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 20,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 21,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 22,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 23,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 24,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 25,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 26,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 27,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 28,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 29,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 31,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 32,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 33,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 34,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SEND_STRING = 35,           /* RAW_SEND_STRING  */
  YYSYMBOL_SAT = 36,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 37,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 38,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 39,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 40,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 41,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 42,                   /* DPAS_OP  */
  YYSYMBOL_NBARRIER_SIGNAL = 43,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 44,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 45,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 46,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 47,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 48,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 49,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 50,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 51,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 52,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 53,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 54,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 55,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 56,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 57,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 58,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 59,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 60,                    /* RBRACE  */
  YYSYMBOL_DOT = 61,                       /* DOT  */
  YYSYMBOL_COMMA = 62,                     /* COMMA  */
  YYSYMBOL_SEMI = 63,                      /* SEMI  */
  YYSYMBOL_COLON = 64,                     /* COLON  */
  YYSYMBOL_SLASH = 65,                     /* SLASH  */
  YYSYMBOL_PERCENT = 66,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 67,                    /* EQUALS  */
  YYSYMBOL_PLUS = 68,                      /* PLUS  */
  YYSYMBOL_MINUS = 69,                     /* MINUS  */
  YYSYMBOL_TIMES = 70,                     /* TIMES  */
  YYSYMBOL_AMP = 71,                       /* AMP  */
  YYSYMBOL_CIRC = 72,                      /* CIRC  */
  YYSYMBOL_PIPE = 73,                      /* PIPE  */
  YYSYMBOL_TILDE = 74,                     /* TILDE  */
  YYSYMBOL_BANG = 75,                      /* BANG  */
  YYSYMBOL_QUESTION = 76,                  /* QUESTION  */
  YYSYMBOL_LEQ = 77,                       /* LEQ  */
  YYSYMBOL_GEQ = 78,                       /* GEQ  */
  YYSYMBOL_EQ = 79,                        /* EQ  */
  YYSYMBOL_NEQ = 80,                       /* NEQ  */
  YYSYMBOL_SHL = 81,                       /* SHL  */
  YYSYMBOL_SHRS = 82,                      /* SHRS  */
  YYSYMBOL_SHRZ = 83,                      /* SHRZ  */
  YYSYMBOL_LABEL = 84,                     /* LABEL  */
  YYSYMBOL_IDENT = 85,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 86,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 87,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 88,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 89,                   /* NEWLINE  */
  YYSYMBOL_RTWRITE_OPTION = 90,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 91,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 92,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 93,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 94,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 95,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 96,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 97,             /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 98,               /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 99,            /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 100,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 101,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 102,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 103,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 104,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 105,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 106,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 107,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 108,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 109,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 110,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 111,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 112,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 113,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 114,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 115,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 116,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 117,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 118,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 119,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 120,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 121,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 122,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 123,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 124,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 125,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 126,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 127,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 128,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 129,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 130,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 131,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 132,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 133,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 134,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 135,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 136,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 137,                   /* IFCALL  */
  YYSYMBOL_FCALL = 138,                    /* FCALL  */
  YYSYMBOL_FADDR = 139,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 140,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 141,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 142,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 143,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 144,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 145,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 146,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 147,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 148,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 149,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 150,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 151,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 152,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 153,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 154,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 155,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 156,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 157,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 158,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 159,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 160,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 161,                   /* AVS_OP  */
  YYSYMBOL_CALL_OP = 162,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 163,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 164,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 165,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 166,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 167,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 168,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 169, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 170,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 171,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 172,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 173,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 174, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 175, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 176,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 177,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 178,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 179,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 180,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 181,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 182,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 183,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 184,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 185,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 186, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 187, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 188,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 189, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 190, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 191,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 192, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 193,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 194,                  /* FCVT_OP  */
  YYSYMBOL_YYACCEPT = 195,                 /* $accept  */
  YYSYMBOL_Listing = 196,                  /* Listing  */
  YYSYMBOL_ListingHeader = 197,            /* ListingHeader  */
  YYSYMBOL_Statements = 198,               /* Statements  */
  YYSYMBOL_Newlines = 199,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 200,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 201,                /* Statement  */
  YYSYMBOL_Scope = 202,                    /* Scope  */
  YYSYMBOL_ScopeStart = 203,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 204,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 205,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 206,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 207,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 208,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 209,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 210,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 211,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 212,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 213,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 214,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 215,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 216,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 217,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 218,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 219,              /* InputOffset  */
  YYSYMBOL_InputSize = 220,                /* InputSize  */
  YYSYMBOL_DirectiveParameter = 221,       /* DirectiveParameter  */
  YYSYMBOL_DirectiveAttr = 222,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 223,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 224,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 225,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 226,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 227,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 228,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 229,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 230,              /* Instruction  */
  YYSYMBOL_Label = 231,                    /* Label  */
  YYSYMBOL_LogicInstruction = 232,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 233,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 234,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 235,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 236,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 237,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 238,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 239,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 240,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 241,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 242,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 243,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 244,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 245,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 246,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 247,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 248,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 249,           /* MovInstruction  */
  YYSYMBOL_MovsInstruction = 250,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 251,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 252,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 253,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 254,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 255,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 256, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 257, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 258, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 259,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 260,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 261,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 262,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 263,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 264,      /* Sample3dInstruction  */
  YYSYMBOL_Sample3DInstruction = 265,      /* Sample3DInstruction  */
  YYSYMBOL_CPSEnableOpt = 266,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 267, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 268,        /* Load3dInstruction  */
  YYSYMBOL_Load3DInstruction = 269,        /* Load3DInstruction  */
  YYSYMBOL_Gather43dInstruction = 270,     /* Gather43dInstruction  */
  YYSYMBOL_Gather43DInstruction = 271,     /* Gather43DInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 272,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 273,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 274,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 275,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 276,       /* RTWriteInstruction  */
  YYSYMBOL_RTWInstruction = 277,           /* RTWInstruction  */
  YYSYMBOL_RTWriteModeOpt = 278,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 279,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 280,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 281,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 282,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 283,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 284,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 285,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 286,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 287,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 288,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 289,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 290,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 291,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 292,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 293,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 294,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 295,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 296,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 297,                 /* LscFence  */
  YYSYMBOL_LscSfid = 298,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 299,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 300,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 301, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 302, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrOperand = 303,      /* LscTypedAddrOperand  */
  YYSYMBOL_LscAddrImmOffsetOpt = 304,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 305,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 306,          /* LscAddrModelOpt  */
  YYSYMBOL_LscRegAddrModel = 307,          /* LscRegAddrModel  */
  YYSYMBOL_LscRegAddrModelKind = 308,      /* LscRegAddrModelKind  */
  YYSYMBOL_LscVectorOpRegOrImm = 309,      /* LscVectorOpRegOrImm  */
  YYSYMBOL_LscVectorOpImm = 310,           /* LscVectorOpImm  */
  YYSYMBOL_LscVectorOpReg = 311,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 312,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 313,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 314,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 315,     /* LscPayloadNonNullReg  */
  YYSYMBOL_SwitchLabels = 316,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 317,        /* BranchInstruction  */
  YYSYMBOL_FILE = 318,                     /* FILE  */
  YYSYMBOL_LOC = 319,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 320,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 321,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 322,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 323,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 324,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 325,            /* OwordModifier  */
  YYSYMBOL_Predicate = 326,                /* Predicate  */
  YYSYMBOL_PredSign = 327,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 328,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 329,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 330,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 331,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 332,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 333,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 334,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 335, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 336,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 337,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 338,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 339,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 340,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 341,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 342,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 343,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 344,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 345,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 346,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 347,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 348,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 349,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 350,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 351,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 352,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 353,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 354,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 355,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 356,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 357,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 358,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 359,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 360,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 361,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 362,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 363,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 364,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 365,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 366,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 367,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 368,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 369,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 370,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 371,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 372,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 373,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 374,              /* ExecSizeInt  */
  YYSYMBOL_Var = 375,                      /* Var  */
  YYSYMBOL_VarNonNull = 376,               /* VarNonNull  */
  YYSYMBOL_IntExp = 377,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 378,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 379,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 380,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 381,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 382,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 383,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 384,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 385,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 386,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 387,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 388,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 389,               /* IntExpPrim  */
  YYSYMBOL_DataType = 390,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 391       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3024

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  195
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  197
/* YYNRULES -- Number of rules.  */
#define YYNRULES  437
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1098

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   449


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   618,   618,   623,   625,   625,   627,   627,   628,   628,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   646,   647,   648,   652,   656,   659,   659,   666,   674,
     682,   689,   690,   691,   692,   693,   694,   696,   703,   711,
     719,   726,   730,   730,   733,   741,   746,   758,   765,   773,
     773,   774,   781,   787,   791,   795,   799,   804,   810,   810,
     812,   816,   822,   830,   836,   841,   846,   852,   856,   860,
     866,   871,   877,   881,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   943,   947,   953,   958,   964,   972,
     978,   985,   992,   999,  1006,  1018,  1025,  1034,  1044,  1050,
    1057,  1063,  1072,  1082,  1089,  1096,  1104,  1113,  1120,  1127,
    1133,  1139,  1145,  1163,  1170,  1180,  1188,  1195,  1202,  1211,
    1220,  1229,  1237,  1240,  1243,  1246,  1249,  1254,  1261,  1269,
    1270,  1276,  1285,  1293,  1300,  1303,  1318,  1318,  1320,  1320,
    1322,  1325,  1338,  1341,  1354,  1354,  1357,  1365,  1373,  1376,
    1380,  1385,  1388,  1400,  1400,  1404,  1412,  1424,  1440,  1446,
    1459,  1467,  1474,  1480,  1486,  1492,  1499,  1500,  1509,  1510,
    1511,  1513,  1514,  1515,  1517,  1520,  1521,  1522,  1523,  1525,
    1547,  1578,  1607,  1632,  1656,  1683,  1709,  1743,  1783,  1823,
    1854,  1889,  1894,  1894,  1897,  1898,  1899,  1903,  1912,  1918,
    1926,  1949,  1960,  1971,  1982,  1995,  1996,  1997,  2004,  2005,
    2008,  2009,  2010,  2011,  2015,  2020,  2021,  2022,  2024,  2024,
    2027,  2032,  2040,  2048,  2062,  2066,  2072,  2077,  2080,  2084,
    2087,  2092,  2095,  2098,  2105,  2109,  2113,  2117,  2123,  2128,
    2135,  2140,  2145,  2151,  2158,  2165,  2171,  2177,  2185,  2193,
    2201,  2210,  2215,  2220,  2225,  2230,  2235,  2240,  2245,  2250,
    2250,  2256,  2261,  2266,  2266,  2268,  2268,  2271,  2271,  2274,
    2275,  2276,  2277,  2279,  2279,  2284,  2285,  2287,  2288,  2292,
    2293,  2296,  2297,  2300,  2301,  2302,  2305,  2306,  2309,  2310,
    2311,  2314,  2315,  2318,  2319,  2321,  2323,  2333,  2340,  2348,
    2356,  2375,  2387,  2394,  2406,  2411,  2418,  2423,  2431,  2439,
    2445,  2450,  2472,  2476,  2482,  2492,  2500,  2507,  2517,  2523,
    2530,  2534,  2539,  2543,  2549,  2550,  2557,  2565,  2566,  2572,
    2582,  2590,  2599,  2617,  2631,  2634,  2645,  2656,  2661,  2666,
    2674,  2683,  2695,  2709,  2711,  2722,  2734,  2740,  2748,  2757,
    2757,  2758,  2758,  2761,  2763,  2764,  2766,  2767,  2769,  2770,
    2772,  2773,  2775,  2776,  2777,  2779,  2780,  2781,  2782,  2783,
    2800,  2803,  2804,  2805,  2806,  2808,  2809,  2810,  2812,  2813,
    2818,  2823,  2825,  2826,  2827,  2828,  2832,  2833,  2835,  2839,
    2843,  2849,  2858,  2859,  2860,  2861,  2863,  2864
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ",
  "ATTR_EQ", "OFFSET_EQ", "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ",
  "V_TYPE_EQ_G", "V_TYPE_EQ_P", "V_TYPE_EQ_A", "V_TYPE_EQ_S",
  "V_TYPE_EQ_T", "CPS", "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK",
  "RAW_SENDC_STRING", "RAW_SENDSC_EOT_STRING", "RAW_SENDSC_STRING",
  "RAW_SENDS_EOT_STRING", "RAW_SENDS_STRING", "RAW_SEND_STRING", "SAT",
  "SRCMOD_ABS", "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP",
  "DPAS_OP", "NBARRIER_SIGNAL", "NBARRIER_WAIT", "ITYPE", "DECL_DATA_TYPE",
  "DFTYPE", "FTYPE", "HFTYPE", "VTYPE", "COND_MOD", "LANGLE", "RANGLE",
  "LBRACK", "RBRACK", "IND_LBRACK", "LPAREN", "RPAREN", "LBRACE", "RBRACE",
  "DOT", "COMMA", "SEMI", "COLON", "SLASH", "PERCENT", "EQUALS", "PLUS",
  "MINUS", "TIMES", "AMP", "CIRC", "PIPE", "TILDE", "BANG", "QUESTION",
  "LEQ", "GEQ", "EQ", "NEQ", "SHL", "SHRS", "SHRZ", "LABEL", "IDENT",
  "BUILTIN_NULL", "BUILTIN", "STRING_LIT", "NEWLINE", "RTWRITE_OPTION",
  "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL", "CHANNEL_OUTPUT",
  "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP", "UNARY_LOGIC_OP",
  "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP", "QUATERNARY_LOGIC_OP", "SEL_OP",
  "MIN_OP", "MAX_OP", "ANTI_TRIG_OP", "MATH2_OP", "MATH3_OP", "ARITH2_OP",
  "ARITH3_OP", "ARITH4_OP", "ARITH4_OP2", "CMP_OP", "SVM_OP",
  "SVM_SCATTER_OP", "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP",
  "SVM_ATOMIC_OP", "OWORD_OP", "MEDIA_OP", "SCATTER_OP",
  "SCATTER_TYPED_OP", "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP",
  "BARRIER_OP", "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP",
  "TYPED_ATOMIC_OP", "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP",
  "VME_SIC_OP", "VME_FBR_OP", "BRANCH_OP", "RET_OP", "IFCALL", "FCALL",
  "FADDR", "SWITCHJMP_OP", "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP",
  "LOC_OP", "CACHE_FLUSH_OP", "WAIT_OP", "FENCE_GLOBAL_OP",
  "FENCE_LOCAL_OP", "FENCE_SW_OP", "YIELD_OP", "SAMPLE_3D_OP",
  "LOAD_3D_OP", "SAMPLE4_3D_OP", "RESINFO_OP_3D", "SAMPLEINFO_OP_3D",
  "RTWRITE_OP_3D", "URBWRITE_OP_3D", "LIFETIME_START_OP",
  "LIFETIME_END_OP", "AVS_OP", "CALL_OP", "PRED_CNTL", "F32_LIT",
  "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_AM_ARG", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveParameter", "DirectiveAttr", "DirectiveFunc",
  "AlignAttrOpt", "Align", "AliasAttrOpt", "OneAttr", "AttrOpt",
  "GenAttrOpt", "Instruction", "Label", "LogicInstruction",
  "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND", "DpasInstruction",
  "BfnInstruction", "QwScatterInstruction", "FCvtInstruction",
  "AntiTrigInstruction", "AddrAddInstruction", "SetpInstruction",
  "SelInstruction", "MinInstruction", "MaxInstruction", "MovInstruction",
  "MovsInstruction", "CmpInstruction", "MediaInstruction",
  "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "Sample3DInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Load3DInstruction", "Gather43dInstruction",
  "Gather43DInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperands", "RTWriteInstruction",
  "RTWInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrOperand",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscRegAddrModel", "LscRegAddrModelKind", "LscVectorOpRegOrImm",
  "LscVectorOpImm", "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D",
  "LscPayloadReg", "LscPayloadNonNullReg", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NullaryInstruction", "OwordModifier", "Predicate", "PredSign",
  "PredCtrlOpt", "SatModOpt", "SrcModifier", "ConditionalModifier",
  "VecDstOperand_A", "VecDstOperand_G", "VecDstOperand_G_I",
  "VecSrcOperand_G_I_IMM_A_AO", "VecSrcOperand_G_I_IMM_A",
  "VecSrcOperand_G_I_IMM", "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO",
  "VecSrcOperand_G_A", "VecSrcOperand_G_A_AO", "VecSrcOperand_G",
  "VecSrcOpndSimple", "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand",
  "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-983)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-427)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -27,  -983,    87,    46,   109,  -983,  -983,   -37,   -27,  -983,
     107,  2758,    -1,    89,    14,   113,    14,   119,   155,    14,
     170,   172,   206,   567,   567,   194,  -983,  -983,   206,   223,
     206,   184,   201,   238,  -983,  -983,  -983,   212,   226,   271,
     181,   288,    14,   206,   206,   206,   262,   187,  -983,  1125,
     293,   298,  -983,  -983,   307,   329,   343,   344,   339,   -71,
     319,   -27,  -983,  -983,  2422,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  2832,  -983,   338,
    -983,  -983,  -983,  -983,  -983,   413,   413,  -983,   367,   417,
     -44,   257,  -983,  -983,  -983,  -983,   181,   190,   450,   190,
     190,  -983,  -983,  -983,  -983,  -983,   224,   327,   -12,  -983,
     -19,   567,  -983,  -983,  -983,  -983,  -983,  -983,   388,   384,
    -983,    51,  -983,  -983,  -983,   181,   181,  -983,   206,   567,
    -983,   206,   384,   276,   206,   386,   350,   279,   181,   257,
     567,   181,   -19,   567,   181,   181,  -983,  -983,   181,  -983,
    -983,  -983,  -983,  -983,   206,   206,  -983,  -983,   181,  -983,
    -983,   266,  -983,   206,  1865,  -983,  -983,  2590,   206,   238,
     238,   238,   238,   206,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   206,   387,
     356,   357,   447,   359,   392,   363,   454,   457,   206,   206,
     206,   206,   319,   434,   434,   434,   377,   206,   206,   407,
     124,   287,   290,   129,   291,   292,   133,   294,   425,   458,
     460,   462,   464,   190,    32,   417,    59,   190,   459,  -983,
     426,   423,   427,   257,  -983,   431,   -11,   436,   190,  -983,
    -983,   438,  -983,    75,   422,   428,  -983,   158,   -13,  -983,
      11,     5,  -983,   240,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,   415,  -983,   388,   384,  -983,   190,
    -983,   248,   190,   446,  -983,  -983,  -983,   340,  -983,   244,
    -983,  -983,   445,   -19,   257,   181,   181,  -983,   184,   342,
     181,   181,   442,   257,   257,   451,   257,  -983,  -983,  -983,
     465,   100,   455,   181,   567,  -983,   146,   567,   181,   181,
     181,   332,   181,  -983,  -983,   -27,  -983,   349,   238,   238,
     238,   238,   351,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   -19,   354,   206,
     206,   461,   206,   355,   206,   467,   467,    14,  -983,   567,
     441,   206,  -983,   496,   439,   440,  -983,   206,   369,    14,
     372,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   312,   524,   190,   190,   190,   190,  -983,   485,   459,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,   380,   381,   257,
     -25,  -983,  -983,   190,   190,  -983,   190,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   491,   248,   446,   260,     8,  -983,
    -983,  -983,  -983,  -983,   489,   190,  -983,  -983,   494,   181,
    -983,  1063,  -983,  -983,   502,  -983,  -983,   500,   190,   567,
     567,   100,  -983,   567,  1104,   181,   501,   312,   181,   394,
     257,   257,   567,   257,   190,   248,  -983,   465,    -4,  -983,
     504,  -983,  -983,   506,   190,  -983,   257,   257,   567,  -983,
    1125,   498,   398,   238,   238,   238,   238,   405,   -19,   -19,
     -19,   -19,   -19,   -19,   -19,   -19,   -19,   -19,   -19,   -19,
     -19,   -19,   -19,   511,   567,   567,   408,   206,   181,   206,
     181,   409,   206,   206,  -983,   416,   418,   -19,  -983,   545,
     206,   206,   181,   419,  -983,   206,   410,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   427,   258,  -983,
    -983,   431,   190,   459,   459,   559,   559,   505,  -983,   525,
    -983,   181,   190,  -983,   534,   533,   422,   -14,   428,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,     5,     5,   264,   264,
     264,  -983,  -983,  -983,  -983,  -983,  -983,   429,   190,   190,
     190,   530,  -983,  -983,  -983,  -983,  -983,  -983,   190,   190,
     538,   567,   567,   257,   130,   567,   567,   567,  -983,   257,
     257,   567,   539,   257,  -983,   536,   257,   546,  -983,  -983,
      -4,    -4,   542,   190,   190,   104,   257,  -983,   567,  -983,
    -983,   437,   206,   206,   238,   238,   443,   567,   567,   181,
     567,   181,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   444,   257,   257,  -983,   257,   257,
     181,   567,  -983,   181,   181,   456,   469,   204,   204,   148,
    -983,   499,   567,   567,  -983,   257,   181,  -983,   312,   312,
     312,   312,   209,   258,   209,   432,   312,   312,  -983,  -983,
    -983,  -983,   556,   586,  -983,  -983,   535,   459,   459,   554,
    -983,    83,  -983,  -983,   384,   568,  -983,  -983,   190,   572,
     565,   573,   582,   171,   587,  -983,  -983,  -983,   567,   257,
     257,   257,   257,   567,  -983,   257,   567,  -983,  -983,  -983,
    -983,  -983,   585,   200,  -983,  -983,   567,  1125,  1125,  1125,
     206,   206,  1125,   567,  -983,  -983,   567,   181,   567,   567,
     567,   567,   567,  -983,  -983,   567,  -983,   567,   567,   567,
     206,   257,   257,   257,   257,   567,   257,   257,   257,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,   500,   206,
     181,   181,  1148,   257,   257,   209,   162,   258,   209,   432,
     474,  -983,  -983,   312,   590,  -983,   312,   596,  -983,   312,
     602,   603,   312,   209,   258,    40,    15,   625,  -983,  -983,
    -983,  -983,   479,  -983,   505,  -983,  -983,  -983,  -983,   190,
    -983,  -983,   190,   257,  -983,   257,   257,   257,   567,   257,
     600,  -983,   567,   257,  1125,  1125,  1125,  1125,   257,   567,
    -983,  -983,   567,   567,  -983,  -983,  -983,  -983,  -983,   567,
    -983,   257,  -983,  -983,   257,   257,   257,   257,   257,   257,
     567,   257,   181,  -983,  -983,   257,   257,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,   190,  -983,   145,  -983,   190,
     181,  -983,   312,   312,   601,  -983,  -983,   191,  -983,  -983,
    -983,  -983,  -983,   608,   459,  -983,  -983,  -983,   609,   610,
    -983,  -983,  -983,   257,   567,   257,  -983,   567,   257,   257,
     257,  1125,  1125,   257,  -983,  -983,   567,  -983,   257,   257,
     257,   257,  -983,   257,   257,   181,  -983,   257,   257,  -983,
     145,    66,    33,  -983,   431,   145,   599,   312,   312,  -983,
     190,   515,    34,  -983,  -983,  -983,  -983,   257,  -983,   567,
    -983,   257,   257,   257,   257,  -983,  -983,  -983,  -983,   257,
    -983,   257,   257,   181,   257,  -983,  -983,   270,   190,   510,
     145,   270,    40,  -983,  -983,   604,  -983,  -983,   606,  -983,
     567,   257,   257,   257,   257,  -983,  -983,   257,   257,  -983,
     257,   190,    25,   628,  -983,    36,    49,   623,   190,   190,
     591,  -983,  -983,   257,   257,   257,  -983,   264,  -983,   514,
     518,   145,    40,    40,   633,   639,   567,  -983,  -983,   257,
     257,  -983,  -983,    62,   638,   632,  -983,  -983,   607,  -983,
     526,   145,   531,    40,   567,  -983,   642,  -983,   643,   257,
     532,    40,  -983,  -983,   644,    40,   646,  -983
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   301,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   303,    24,   124,     0,   313,
       0,   299,     0,     0,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   291,     0,
     294,   296,   298,   293,     0,     0,     0,     0,     0,     0,
     307,     8,     5,    20,     0,    11,    12,    10,    36,    31,
      32,    33,    34,    35,    14,    13,    15,    17,    16,    18,
      19,    74,    76,    77,    78,    79,    80,    81,   119,   120,
     121,   123,    82,    83,   104,   101,   102,   103,   100,    99,
      84,    85,    87,    88,    90,    89,    91,    93,    94,    96,
      95,   109,   174,   110,   180,   111,   182,   112,   113,   114,
     191,   115,    98,    97,    86,    75,   122,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    92,
     105,   106,   107,   116,   117,   108,   118,     0,    30,     0,
      26,    27,    57,    37,    29,    49,    49,    28,    55,     0,
       0,     0,   310,   309,   311,   312,     0,     0,     0,     0,
       0,   391,   390,   392,   364,   367,   426,   427,     0,   431,
       0,     0,   323,   335,   325,   360,   362,   324,     0,     0,
     389,     0,   425,   166,   304,     0,     0,   314,     0,     0,
     300,     0,     0,     0,     0,   383,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   281,   282,     0,   292,
     326,   327,   295,   297,     0,     0,   285,   286,     0,   232,
     233,     0,   308,     0,   301,     2,    23,   301,     0,     0,
       0,     0,     0,     0,   307,   307,   307,   307,   307,   307,
     307,   307,   307,   307,   307,   307,   307,   307,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   307,   184,   184,   184,   193,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    72,    46,    56,     0,    72,   388,
       0,     0,     0,     0,   341,     0,     0,     0,     0,   426,
     427,     0,   393,   395,   397,   399,   401,   404,   409,   410,
     414,   417,   421,   427,   361,   363,   422,   423,   424,   368,
     365,   369,   366,   359,     0,   429,     0,     0,   165,     0,
     374,     0,     0,     0,   436,   437,   358,   305,   380,     0,
     315,   348,     0,     0,     0,     0,     0,   385,   299,     0,
       0,     0,     0,     0,     0,     0,     0,   280,   317,   318,
       0,     0,     0,     0,     0,   316,     0,     0,     0,     0,
       0,     0,     0,     4,    25,     8,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   206,     0,     0,     0,   169,   169,     0,   276,     0,
       0,     0,   185,   176,     0,     0,   194,     0,     0,     0,
       0,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,     0,     0,     0,     0,     0,     0,    50,     0,    72,
      48,    45,    53,    54,    51,    52,   386,     0,     0,     0,
       0,   343,   378,     0,     0,   428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   409,   433,
     434,   435,   370,   432,     0,     0,   356,   306,     0,     0,
     333,     0,   331,   334,   352,   332,   355,     0,     0,     0,
       0,   380,   201,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   350,     0,   271,   151,
       0,   152,   150,     0,     0,   143,     0,     0,     0,   231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   274,     0,     0,     0,   177,   178,
       0,     0,     0,     0,   275,     0,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   390,     0,   267,
     268,   389,     0,    72,    72,    42,    42,     0,    47,     0,
     342,     0,     0,   344,     0,     0,   396,     0,   398,   400,
     402,   403,   405,   406,   407,   408,   415,   416,   411,   412,
     413,   419,   420,   418,   430,   371,   357,     0,     0,   376,
       0,     0,   302,   354,   142,   328,   330,   329,     0,     0,
       0,     0,     0,     0,   157,     0,     0,     0,   384,     0,
       0,     0,     0,     0,   198,     0,     0,     0,   351,   349,
     271,   271,     0,     0,     0,     0,     0,   187,     0,   140,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,     0,   170,     0,     0,     0,     0,     0,     0,     0,
     179,     0,     0,     0,   188,     0,     0,   236,     0,     0,
       0,     0,   250,     0,   250,     0,     0,     0,   257,   255,
     256,   230,     0,    58,    40,    39,     0,    72,    72,    69,
      71,     0,   387,   137,     0,     0,   377,   381,     0,     0,
       0,     0,     0,     0,     0,   154,   153,   200,     0,     0,
       0,     0,     0,     0,   337,     0,     0,   199,   372,   272,
     273,   277,     0,     0,   340,   186,     0,     0,     0,     0,
       0,     0,     0,     0,   129,   130,     0,     0,     0,     0,
       0,     0,     0,   141,   131,     0,   133,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   279,
     278,   148,   319,   321,   320,   322,   147,   149,   380,     0,
       0,     0,   192,     0,     0,   250,     0,     0,   250,     0,
       0,   251,   252,     0,     0,   253,     0,     0,   239,     0,
       0,     0,     0,   250,     0,     0,     0,    64,    59,    43,
      41,    44,     0,    73,     0,   336,   345,   394,   375,     0,
     379,   353,     0,     0,   156,     0,     0,     0,     0,     0,
       0,   339,     0,     0,     0,     0,     0,     0,     0,     0,
     125,   126,     0,     0,   144,   145,   146,   132,   134,     0,
     136,     0,   204,   205,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   189,   190,     0,     0,   220,   264,   265,
     227,   221,   222,   266,   223,   248,   228,     0,   224,   248,
       0,   225,     0,     0,     0,   259,   258,   261,   260,    63,
      60,    61,    62,     0,    72,    68,    67,    70,     0,     0,
     155,   158,   173,     0,     0,     0,   338,     0,     0,     0,
       0,     0,     0,     0,   138,   127,     0,   135,     0,     0,
       0,     0,   160,     0,     0,     0,   346,     0,     0,   139,
       0,     0,     0,   269,   270,     0,     0,     0,     0,   254,
       0,     0,     0,    38,   373,   382,   172,     0,   197,     0,
     284,     0,     0,     0,     0,   283,   128,   202,   203,     0,
     161,     0,     0,     0,   181,   346,   195,   245,   249,     0,
       0,   245,     0,   226,   229,     0,   262,    66,     0,   171,
       0,     0,     0,     0,     0,   159,   167,     0,     0,   347,
     183,     0,     0,     0,   241,     0,     0,     0,     0,     0,
       0,   290,   289,     0,     0,     0,   346,   246,   247,     0,
       0,     0,     0,     0,     0,     0,     0,   288,   287,     0,
     175,   237,   242,     0,     0,     0,   263,    65,     0,   168,
       0,     0,     0,     0,     0,   243,     0,   238,     0,     0,
       0,     0,   196,   244,     0,     0,     0,   240
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -983,  -983,  -983,   470,   -51,    -5,   476,  -983,  -983,   167,
      10,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
     105,  -983,  -983,  -983,   570,    72,  -983,  -983,  -983,  -983,
    -983,  -983,  -152,  -983,  -293,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,   311,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,   118,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,   283,  -705,  -110,  -109,  -791,  -283,
    -200,  -696,  -584,  -983,  -777,  -983,  -191,  -682,  -106,  -422,
    -825,  -292,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
     390,  -983,  -983,  -983,  1083,    28,  -983,   165,   370,  -338,
      31,  -983,   -23,  -538,  -983,  -983,  -983,    54,  -983,  -983,
    -983,   382,  -983,  1268,  -902,  -983,  -982,  -983,  -197,  -983,
    -315,  -983,   402,  -983,    61,   592,   593,  -983,  -339,  -313,
     430,   277,  -174,  -209,  -983,  -183,  -983,  -219,  2091,   297,
     529,   762,  -143,    -3,   295,   299,   296,   289,   -45,  -335,
    -983,  -471,  -465,   -62,  -275,  -449,   577
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    61,     3,     4,    62,    63,    64,   386,
     152,    65,    66,     9,    67,    68,    69,    70,    71,    72,
     747,    73,    74,    75,   294,   298,    76,    77,    78,   857,
     858,   944,   750,   751,   450,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   655,   102,
     103,   104,   105,   106,   107,   108,   572,   109,   110,   111,
     112,   579,   721,   113,   114,   115,   116,   423,   117,   118,
     832,   119,   120,   427,   121,   122,   123,   124,   125,   567,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   231,   587,   848,   849,   852,   846,  1043,
     980,   844,   845,   742,   934,   935,   936,   835,   839,   836,
     982,   672,   139,   140,   141,   142,   143,   144,   145,   146,
     201,   147,   195,   498,   233,   180,   198,   349,   373,   367,
     821,   822,   823,   219,   644,   500,   501,   182,   753,   208,
     211,   529,   374,   599,   304,   461,  1014,   350,   368,   369,
     824,   504,   825,   183,   184,   185,   186,   187,   526,   340,
     341,   188,   343,   347,   306,   506,   360,   204,   161,   300,
     189,   190,   938,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   191,   192,   492,   493
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     181,   193,   679,    11,   488,   455,   377,   628,   629,   630,
     234,   626,   627,   351,   741,   509,   939,   375,   940,   598,
     388,   389,   390,   391,   311,   983,   154,   843,   356,   157,
     496,   525,   612,  1040,   503,  1027,   635,   166,   850,   472,
     473,   171,   172,   173,   462,   334,   920,   837,   838,   448,
     758,   463,   212,   297,   853,   854,   235,   466,   670,   237,
     472,   639,     1,   933,   474,   475,   171,   172,   173,   562,
     481,   482,   167,   335,  1070,   483,   668,   218,   983,   476,
     477,   671,   167,   983,   308,   474,   475,     5,  1019,   169,
     170,  1060,   478,   479,   480,  1020,   344,   167,  1061,   150,
     941,   345,   151,   220,  1059,   322,   326,   327,   328,   308,
     221,  1062,   229,   230,   169,   170,   167,  1080,   983,   171,
     172,   173,   299,     7,  1081,   171,   172,   173,   308,    10,
     917,   481,   482,   169,   170,     6,  1018,   622,   623,   624,
     625,   613,   850,   863,   510,   864,   466,   452,   932,   847,
     447,   467,   524,   453,   454,  1017,   608,   342,   338,   983,
    1021,   924,   784,   486,   926,   148,   640,   928,    12,   543,
     544,   545,   546,   636,   149,  -426,   354,   329,   330,   983,
    -426,   309,   310,   178,   179,   375,   646,   365,   669,   667,
     372,   309,   310,   178,   179,  1045,   487,   527,   524,   494,
     524,   153,   527,   534,   155,   649,   309,   310,   178,   179,
     687,   688,   690,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   309,   310,   178,   179,   764,
     171,   322,   173,   640,   322,   322,  1073,   470,   471,   718,
     156,   162,   163,   164,   165,  1047,   326,   167,   990,   883,
     884,   885,   991,   847,   888,   158,  1086,   159,   881,   308,
     166,   167,   640,   160,   169,   170,   171,   172,   173,   194,
     847,   329,   330,   168,   197,   499,   200,   322,   169,   170,
     322,   162,   163,   164,   165,  1074,  1075,   331,   332,   171,
     172,   173,   202,   344,   913,   489,   490,   491,   345,   203,
     603,   604,   605,   606,   623,   205,  1088,   431,   432,   840,
     744,   745,   435,   436,  1094,   499,   439,   440,  1096,   206,
     614,   615,   637,   638,   682,   683,   684,   685,   207,   171,
     172,   173,   476,   477,   234,   918,   919,   527,  1041,  1042,
     689,   691,   171,   302,   173,   210,   959,   960,   961,   962,
     216,   531,   641,   217,   535,   232,   309,   310,   178,   179,
     288,   289,   290,   291,   292,   650,   449,   451,   174,   175,
     176,   177,   178,   179,   331,   332,   333,   218,   779,   780,
     541,   322,   322,   322,   322,   841,   738,   739,   740,   842,
     222,   675,   424,   425,   351,   223,   575,   171,   597,   173,
     224,   322,   322,   502,   322,   322,   322,   322,   322,   322,
     322,   322,   322,   322,   322,   322,   322,   322,   322,   631,
     632,   633,   225,  1003,  1004,   620,   621,   574,   226,   227,
     840,   293,   228,   322,   296,   738,   739,   740,   297,   584,
     339,   342,   357,   359,   361,   362,   322,   381,   408,   409,
     410,   411,   412,   413,   860,   861,   414,   336,   415,   743,
     981,   416,   322,   422,   981,   790,   791,   426,   430,   755,
     433,   442,   322,   434,   437,   438,   448,   443,   441,   444,
     795,   445,   797,   446,   456,   457,   651,   652,   458,   370,
     653,   656,   460,   464,   468,   760,   465,   761,   495,   665,
     484,   469,   508,   497,   519,   762,   763,   167,   516,   827,
     987,   988,   528,   522,   539,   678,   542,   524,   547,   308,
     563,   569,   566,   578,   169,   170,   576,   946,   571,   218,
     782,   783,   580,   581,   948,   583,   167,   949,   585,   586,
     322,   705,   706,   602,   607,   527,   299,   610,   308,   634,
     322,   640,   642,   169,   170,   645,   648,   649,   384,   658,
     662,   673,   647,   674,   681,  1023,  1024,   945,   218,   209,
    1057,   686,   704,   720,   707,   712,   322,   322,   322,   746,
     865,   727,   715,   752,   716,   725,   322,   322,   891,   756,
     749,   757,   829,   638,   220,   759,   764,   774,   776,   778,
     781,   221,   856,   787,   162,   163,   164,   165,   851,   792,
     810,   322,   322,   855,   174,   175,   176,   323,   178,   179,
     859,   862,   819,   166,   167,   868,   866,   869,   765,   766,
     370,   870,   768,   769,   770,   820,   168,   871,   773,   872,
     943,   169,   170,   881,   925,   309,   310,   178,   179,   923,
     927,   993,   171,   172,   173,   786,   929,   930,   956,   989,
     992,  1022,   994,   995,   793,   794,  1048,   796,  1049,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,  1026,  1044,  1059,   370,  1063,  1071,  1066,   816,   301,
    1072,  1076,  1077,  1082,  1083,   307,   322,  1090,  1085,   830,
     831,  1097,  1084,  1087,  1093,  1091,  1095,   385,   680,   337,
     383,   748,   947,   942,  1065,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   348,   352,   295,   573,   921,   985,
     922,   174,   175,   176,   177,   178,   179,   363,  1046,   986,
     366,   371,   717,   376,   348,   873,   931,   337,   515,   826,
     878,   505,   540,   880,   609,   867,   532,   380,   619,     0,
     324,   325,   617,   882,   618,   616,   485,  1058,   346,     0,
     889,     0,     0,   890,     0,   892,   893,   894,   895,   896,
       0,     0,   897,     0,   898,   899,   900,     0,     0,     0,
       0,     0,   906,   322,   322,     0,     0,     0,     0,     0,
     322,     0,     0,     0,     0,     0,     0,   322,     0,     0,
     322,     0,     0,     0,     0,   218,   218,   218,     0,     0,
     218,     0,     0,     0,     0,   370,   370,   370,   370,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   370,
       0,   220,   220,   220,     0,     0,   220,  1025,   221,   221,
     221,     0,     0,   221,   370,   954,     0,     0,     0,   957,
     218,     0,     0,   322,     0,     0,   964,   322,     0,   965,
     966,     0,     0,     0,     0,     0,   967,     0,   507,     0,
       0,     0,   511,     0,   513,   514,   220,   975,     0,   517,
     518,     0,     0,   221,     0,     0,     0,     0,     0,     0,
       0,     0,   530,   533,     0,  1064,     0,   536,   537,   538,
       0,   371,   218,   218,   218,   218,     0,     0,     0,     0,
       0,     0,     0,   305,     0,     0,     0,     0,   322,     0,
       0,   997,     0,     0,   999,     0,   371,     0,   220,   220,
     220,   220,     0,  1006,     0,   221,   221,   221,   221,     0,
       0,     0,     0,     0,     0,     0,   633,     0,     0,     0,
     322,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     600,   305,     0,     0,     0,     0,  1030,     0,     0,   322,
       0,     0,     0,     0,     0,     0,   322,   322,     0,   218,
     218,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     322,   322,     0,     0,     0,     0,     0,  1050,     0,     0,
       0,     0,     0,     0,     0,   220,   220,     0,     0,     0,
       0,   322,   221,   221,     0,     0,     0,     0,   643,   322,
       0,     0,     0,   322,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1078,   657,     0,   660,   661,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1089,     0,     0,     0,   305,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   371,   511,   511,
     371,   371,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,     0,     0,     0,     0,     0,   709,     0,   711,
     162,   163,   164,   165,     0,     0,   719,     0,     0,     0,
       0,   724,     0,     0,     0,     0,   305,     0,     0,     0,
     167,     0,     0,     0,     0,   305,   305,     0,   305,     0,
       0,     0,   168,     0,   499,     0,     0,   169,   170,     0,
     754,   162,   163,   164,   165,     0,     0,     0,   171,   172,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     166,   167,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,     0,   168,     0,     0,     0,     0,   169,   170,
       0,     0,   167,     0,     0,   162,   163,   164,   165,   171,
     172,   173,     0,     0,   168,     0,     0,     0,     0,   169,
     170,     0,     0,   601,     0,   167,     0,     0,     0,     0,
     171,   172,   173,     0,     0,     0,     0,   168,   348,     0,
     348,   305,   169,   170,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   171,   597,   173,     0,     0,     0,   815,
       0,     0,   817,   818,     0,     0,   507,   828,     0,     0,
       0,     0,     0,     0,     0,   834,     0,   600,   600,   600,
     600,     0,     0,     0,     0,   600,   600,     0,   174,   175,
     654,   177,   178,   179,     0,     0,     0,     0,     0,   601,
       0,     0,   305,   305,     0,   305,     0,     0,     0,   174,
     175,   176,   177,   178,   179,     0,     0,     0,   305,   305,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,     0,     0,
       0,     0,     0,     0,     0,     0,   348,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   421,     0,     0,     0,   911,
     912,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   600,     0,     0,   600,     0,     0,   600,     0,
       0,   600,     0,     0,   937,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   305,     0,     0,     0,     0,
       0,   305,   305,     0,     0,   305,     0,     0,   305,   303,
       0,     0,     0,     0,     0,     0,     0,     0,   305,     0,
       0,   977,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   937,
       0,   600,   600,     0,     0,     0,     0,   305,   305,     0,
     305,   305,     0,     0,     0,     0,     0,   364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   305,     0,     0,
     601,   601,   601,   601,     0,     0,     0,     0,   601,   601,
       0,     0,     0,     0,  1013,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   600,   600,     0,     0,
       0,  1028,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   305,   305,   305,   305,     0,     0,   305,     0,     0,
       0,     0,  1038,     0,     0,     0,     0,     0,     0,     0,
       0,   937,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   459,     0,   305,   305,   305,   305,     0,   305,   305,
     305,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   937,   937,     0,   601,   305,   305,     0,     0,     0,
       0,     0,     0,     0,     0,   601,     0,     0,   601,     0,
       0,   601,   937,     0,   601,     0,     0,     0,     0,     0,
     937,     0,   512,     0,   937,     0,     0,     0,     0,     0,
       0,   520,   521,     0,   523,   305,     0,   305,   305,   305,
       0,   305,     0,     0,     0,   305,     0,     0,     0,     0,
     305,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   305,     0,     0,   305,   305,   305,   305,
     305,   305,     0,   305,     0,     0,     0,   305,   305,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   984,
       0,     0,     0,     0,   601,   601,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   305,     0,   305,     0,     0,
     305,   305,   305,     0,     0,   305,     0,   611,     0,     0,
     305,   305,   305,   305,     0,   305,   305,     0,     0,   305,
     305,     0,   984,     0,     0,     0,     0,   984,     0,   601,
     601,     0,     0,     0,     0,     0,     0,     0,     0,   305,
       0,     0,     0,   305,   305,   305,   305,     0,     0,     0,
       0,   305,     0,   305,   305,     0,   305,     0,     0,     0,
       0,     0,   984,     0,     0,   659,     0,     0,   663,   664,
       0,   666,     0,   305,   305,   305,   305,     0,     0,   305,
     305,     0,   305,     0,   676,   677,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   305,   305,   305,     0,     0,
       0,     0,     0,   984,     0,     0,     0,     0,     0,     0,
       0,   305,   305,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   984,     0,     0,     0,     0,     0,     0,
       0,   305,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    -9,     0,     0,     0,     0,
      13,    14,    15,    16,    17,    18,    19,    20,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,    23,    24,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   767,    25,     0,    26,    -9,     0,   771,   772,     0,
       0,   775,     0,     0,   777,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   785,     0,     0,     0,     0,    27,
       0,     0,     0,     0,     6,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   811,   812,     0,   813,   814,    29,    30,
       0,     0,     0,     0,    31,    32,    33,     0,     0,     0,
      34,    35,    36,   833,     0,    37,    38,    39,    40,    41,
       0,     0,     0,     0,    42,    43,    44,    45,     0,    46,
      47,    48,    49,    50,    51,    52,    53,     0,     0,     0,
      54,    55,     0,     0,    56,    57,    58,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   874,   875,   876,
     877,     0,     0,   879,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    59,    60,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   902,
     903,   904,   905,     0,   907,   908,   909,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     914,   915,   916,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   196,
       0,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,   214,   215,     0,     0,     0,
       0,   950,     0,   951,   952,   953,     0,   955,     0,     0,
       0,   958,     0,     0,     0,     0,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   968,
       0,     0,   969,   970,   971,   972,   973,   974,     0,   976,
       0,     0,     0,   978,   979,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   996,     0,   998,     0,     0,  1000,  1001,  1002,     0,
       0,  1005,     0,     0,     0,     0,  1007,  1008,  1009,  1010,
       0,  1011,  1012,     0,     0,  1015,  1016,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,  1031,
    1032,  1033,  1034,     0,     0,     0,     0,  1035,     0,  1036,
    1037,     0,  1039,     0,     0,     0,     0,     0,     0,   353,
       0,     0,   355,     0,     0,   358,     0,     0,     0,  1051,
    1052,  1053,  1054,     0,     0,  1055,  1056,     0,  1039,     0,
       0,     0,     0,     0,     0,   378,   379,     0,     0,     0,
       0,  1067,  1068,  1069,   382,     0,     0,     0,     0,   387,
       0,     0,     0,     0,   392,     0,     0,  1079,  1039,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   407,
       0,     0,     0,     0,     0,     0,     0,  1092,     0,   417,
     418,   419,   420,     0,     0,     0,     0,     0,   428,   429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,     0,     0,     0,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    -8,    -8,    -8,    -8,    -8,    -8,     0,     0,
       0,     0,     0,    -8,    -8,    -8,    -8,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    -8,
       0,    -8,    -8,     0,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     0,     0,
     564,   565,     0,   568,     0,   570,    -8,     0,     0,     0,
       0,     1,   577,     0,     0,     0,     0,     0,   582,     0,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,
       0,     0,    -8,     0,     0,    13,    14,    15,    16,    17,
      18,    19,    20,    21,     0,     0,     0,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,    23,    24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,     0,    26,
     384,     0,     0,     0,     0,     0,     0,     0,   708,     0,
     710,     0,     0,   713,   714,     0,     0,     0,     0,     0,
       0,   722,   723,     0,    27,     0,   726,     0,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    29,    30,     0,     0,     0,     0,    31,
      32,    33,     0,     0,     0,    34,    35,    36,     0,     0,
      37,    38,    39,    40,    41,     0,     0,     0,     0,    42,
      43,    44,    45,     0,    46,    47,    48,    49,    50,    51,
      52,    53,     0,     0,     0,    54,    55,     0,     0,    56,
      57,    58,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    13,    14,    15,    16,    17,    18,    19,
      20,    21,     0,   788,   789,     0,     0,     0,     0,     0,
       0,     0,     0,    59,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,    23,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,     0,    26,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,     0,   238,   239,   240,   241,   242,   243,     0,     0,
       0,    29,    30,   244,     0,     0,     0,    31,    32,    33,
       0,   886,   887,    34,    35,    36,     0,     0,    37,    38,
      39,    40,    41,     0,     0,     0,     0,    42,    43,    44,
      45,   901,    46,    47,    48,    49,    50,    51,    52,    53,
       0,     0,     0,    54,    55,     0,     0,    56,    57,    58,
     910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,     0,     0,   259,   260,   261,
     262,    59,    60,     0,   263,   264,   265,     0,     0,     0,
     266,   267,     0,     0,     0,     0,     0,   268,   269,   270,
     271,     0,     0,     0,     0,   272,     0,     0,     0,     0,
       0,     0,     0,     0,   273,   274,   275,     0,     0,   276,
     277,     0,     0,     0,   278,     0,     0,     0,     0,     0,
       0,     0,   279,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287
};

static const yytype_int16 yycheck[] =
{
      23,    24,   540,     8,   339,   298,   215,   478,   479,   480,
      61,   476,   477,   196,   598,   353,     1,   214,     3,   441,
     239,   240,   241,   242,   167,   927,    16,   732,   202,    19,
     343,   370,    57,  1015,   349,     1,   485,    56,   734,    52,
      53,    85,    86,    87,    55,    57,   837,   729,   730,    17,
      64,    62,    42,    21,   736,   737,    61,    71,    62,    64,
      52,    53,    89,   854,    77,    78,    85,    86,    87,   407,
      65,    66,    57,    85,  1056,    70,   525,    49,   980,    68,
      69,    85,    57,   985,    69,    77,    78,     0,    55,    74,
      75,    55,    81,    82,    83,    62,    45,    57,    62,    85,
      85,    50,    88,    49,    55,   167,   168,   169,   170,    69,
      49,    62,   183,   184,    74,    75,    57,    55,  1020,    85,
      86,    87,   166,    14,    62,    85,    86,    87,    69,   166,
     835,    65,    66,    74,    75,    89,    70,   472,   473,   474,
     475,   166,   838,    60,   353,    62,    71,    88,   853,   733,
     293,    76,    52,   296,   297,   980,   449,    57,   181,  1061,
     985,   843,    58,   337,   846,   166,    62,   849,    61,   388,
     389,   390,   391,   486,    85,    45,   199,    47,    48,  1081,
      50,   166,   167,   168,   169,   382,   501,   210,   527,   524,
     213,   166,   167,   168,   169,  1020,   339,   371,    52,   342,
      52,    88,   376,    57,    85,    57,   166,   167,   168,   169,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   166,   167,   168,   169,    58,
      85,   293,    87,    62,   296,   297,  1061,    79,    80,   577,
      85,    37,    38,    39,    40,  1022,   308,    57,    57,   787,
     788,   789,    61,   837,   792,    85,  1081,    85,    58,    69,
      56,    57,    62,    57,    74,    75,    85,    86,    87,    75,
     854,    47,    48,    69,    51,    71,    92,   339,    74,    75,
     342,    37,    38,    39,    40,  1062,  1063,    47,    48,    85,
      86,    87,    91,    45,   832,    47,    48,    49,    50,    61,
     443,   444,   445,   446,   639,    93,  1083,   183,   184,   731,
     603,   604,   183,   184,  1091,    71,   183,   184,  1095,    93,
     463,   464,    62,    63,   543,   544,   545,   546,    57,    85,
      86,    87,    68,    69,   385,   173,   174,   511,    68,    69,
     549,   550,    85,    86,    87,    57,   884,   885,   886,   887,
      88,   374,   495,   166,   377,    36,   166,   167,   168,   169,
      22,    23,    24,    25,    26,   508,   294,   295,   164,   165,
     166,   167,   168,   169,    47,    48,    49,   349,   670,   671,
     385,   443,   444,   445,   446,   176,   177,   178,   179,   180,
      97,   534,   274,   275,   577,    97,   419,    85,    86,    87,
      93,   463,   464,   349,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,    93,   961,   962,   470,   471,   417,    85,    85,
     852,    18,    93,   495,    67,   177,   178,   179,    21,   429,
      52,    57,   166,    57,    94,   166,   508,   181,    61,    93,
      93,     4,    93,    61,   747,   748,    93,   180,     4,   602,
     925,     4,   524,    29,   929,   684,   685,    90,    61,   612,
     183,    46,   534,   183,   183,   183,    17,    19,   184,    19,
     689,    19,   691,    19,    58,    62,   509,   510,    61,   212,
     513,   514,    61,    57,    72,   638,    58,   640,    52,   522,
      85,    73,    57,   163,    62,   648,   649,    57,   166,   718,
     932,   933,    57,    62,   182,   538,   167,    52,   167,    69,
     166,   166,    61,    27,    74,    75,    85,   862,    61,   501,
     673,   674,    93,    93,   869,   166,    57,   872,   166,   171,
     602,   564,   565,    19,    59,   719,   166,   166,    69,    58,
     612,    62,    58,    74,    75,   501,    54,    57,    60,    58,
     166,    57,   501,    57,   166,   987,   988,    88,   540,    40,
    1041,   166,    61,    28,   166,   166,   638,   639,   640,    20,
     754,   171,   166,    58,   166,   166,   648,   649,   797,    55,
      85,    58,    93,    63,   540,   166,    58,    58,    62,    53,
      58,   540,    16,   166,    37,    38,    39,    40,   176,   166,
     166,   673,   674,    57,   164,   165,   166,   167,   168,   169,
      85,    67,   166,    56,    57,    53,    58,    62,   651,   652,
     353,    58,   655,   656,   657,   166,    69,    55,   661,    52,
      15,    74,    75,    58,    54,   166,   167,   168,   169,   175,
      54,   944,    85,    86,    87,   678,    54,    54,    58,    58,
      52,    62,    53,    53,   687,   688,    62,   690,    62,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   166,   172,    55,   407,    62,   172,    96,   711,   160,
     172,    58,    53,    55,    62,   166,   758,    55,   172,   722,
     723,    55,    95,   172,   172,    62,    62,   237,   541,   180,
     234,   606,   864,   856,  1049,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   195,   196,   156,   416,   838,   929,
     839,   164,   165,   166,   167,   168,   169,   208,  1021,   930,
     211,   212,   577,   214,   215,   768,   852,   218,   358,   718,
     773,   349,   382,   776,   457,   758,   374,   228,   469,    -1,
     168,   168,   467,   786,   468,   466,   336,  1042,   191,    -1,
     793,    -1,    -1,   796,    -1,   798,   799,   800,   801,   802,
      -1,    -1,   805,    -1,   807,   808,   809,    -1,    -1,    -1,
      -1,    -1,   815,   855,   856,    -1,    -1,    -1,    -1,    -1,
     862,    -1,    -1,    -1,    -1,    -1,    -1,   869,    -1,    -1,
     872,    -1,    -1,    -1,    -1,   787,   788,   789,    -1,    -1,
     792,    -1,    -1,    -1,    -1,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
      -1,   787,   788,   789,    -1,    -1,   792,   990,   787,   788,
     789,    -1,    -1,   792,   577,   878,    -1,    -1,    -1,   882,
     832,    -1,    -1,   925,    -1,    -1,   889,   929,    -1,   892,
     893,    -1,    -1,    -1,    -1,    -1,   899,    -1,   349,    -1,
      -1,    -1,   353,    -1,   355,   356,   832,   910,    -1,   360,
     361,    -1,    -1,   832,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   373,   374,    -1,  1048,    -1,   378,   379,   380,
      -1,   382,   884,   885,   886,   887,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   161,    -1,    -1,    -1,    -1,   990,    -1,
      -1,   954,    -1,    -1,   957,    -1,   407,    -1,   884,   885,
     886,   887,    -1,   966,    -1,   884,   885,   886,   887,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1018,    -1,    -1,    -1,
    1022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     441,   209,    -1,    -1,    -1,    -1,   999,    -1,    -1,  1041,
      -1,    -1,    -1,    -1,    -1,    -1,  1048,  1049,    -1,   961,
     962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1062,  1063,    -1,    -1,    -1,    -1,    -1,  1030,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   961,   962,    -1,    -1,    -1,
      -1,  1083,   961,   962,    -1,    -1,    -1,    -1,   499,  1091,
      -1,    -1,    -1,  1095,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1066,   515,    -1,   517,   518,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1084,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,    -1,    -1,    -1,    -1,    -1,   568,    -1,   570,
      37,    38,    39,    40,    -1,    -1,   577,    -1,    -1,    -1,
      -1,   582,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    -1,   363,   364,    -1,   366,    -1,
      -1,    -1,    69,    -1,    71,    -1,    -1,    74,    75,    -1,
     611,    37,    38,    39,    40,    -1,    -1,    -1,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    57,    37,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    74,    75,
      -1,    -1,    57,    -1,    -1,    37,    38,    39,    40,    85,
      86,    87,    -1,    -1,    69,    -1,    -1,    -1,    -1,    74,
      75,    -1,    -1,   441,    -1,    57,    -1,    -1,    -1,    -1,
      85,    86,    87,    -1,    -1,    -1,    -1,    69,   689,    -1,
     691,   459,    74,    75,    -1,    -1,    -1,   164,   165,   166,
     167,   168,   169,    85,    86,    87,    -1,    -1,    -1,   710,
      -1,    -1,   713,   714,    -1,    -1,   717,   718,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   726,    -1,   728,   729,   730,
     731,    -1,    -1,    -1,    -1,   736,   737,    -1,   164,   165,
     166,   167,   168,   169,    -1,    -1,    -1,    -1,    -1,   517,
      -1,    -1,   520,   521,    -1,   523,    -1,    -1,    -1,   164,
     165,   166,   167,   168,   169,    -1,    -1,    -1,   536,   537,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   166,   167,   168,   169,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   797,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,   830,
     831,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   843,    -1,    -1,   846,    -1,    -1,   849,    -1,
      -1,   852,    -1,    -1,   855,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   653,    -1,    -1,    -1,    -1,
      -1,   659,   660,    -1,    -1,   663,    -1,    -1,   666,   161,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   676,    -1,
      -1,   912,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   930,
      -1,   932,   933,    -1,    -1,    -1,    -1,   705,   706,    -1,
     708,   709,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   725,    -1,    -1,
     728,   729,   730,   731,    -1,    -1,    -1,    -1,   736,   737,
      -1,    -1,    -1,    -1,   975,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   987,   988,    -1,    -1,
      -1,   992,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   769,   770,   771,   772,    -1,    -1,   775,    -1,    -1,
      -1,    -1,  1013,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   303,    -1,   811,   812,   813,   814,    -1,   816,   817,
     818,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1062,  1063,    -1,   832,   833,   834,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   843,    -1,    -1,   846,    -1,
      -1,   849,  1083,    -1,   852,    -1,    -1,    -1,    -1,    -1,
    1091,    -1,   354,    -1,  1095,    -1,    -1,    -1,    -1,    -1,
      -1,   363,   364,    -1,   366,   873,    -1,   875,   876,   877,
      -1,   879,    -1,    -1,    -1,   883,    -1,    -1,    -1,    -1,
     888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   901,    -1,    -1,   904,   905,   906,   907,
     908,   909,    -1,   911,    -1,    -1,    -1,   915,   916,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   927,
      -1,    -1,    -1,    -1,   932,   933,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   953,    -1,   955,    -1,    -1,
     958,   959,   960,    -1,    -1,   963,    -1,   459,    -1,    -1,
     968,   969,   970,   971,    -1,   973,   974,    -1,    -1,   977,
     978,    -1,   980,    -1,    -1,    -1,    -1,   985,    -1,   987,
     988,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   997,
      -1,    -1,    -1,  1001,  1002,  1003,  1004,    -1,    -1,    -1,
      -1,  1009,    -1,  1011,  1012,    -1,  1014,    -1,    -1,    -1,
      -1,    -1,  1020,    -1,    -1,   517,    -1,    -1,   520,   521,
      -1,   523,    -1,  1031,  1032,  1033,  1034,    -1,    -1,  1037,
    1038,    -1,  1040,    -1,   536,   537,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1053,  1054,  1055,    -1,    -1,
      -1,    -1,    -1,  1061,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1069,  1070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1081,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1089,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     0,    -1,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   653,    57,    -1,    59,    60,    -1,   659,   660,    -1,
      -1,   663,    -1,    -1,   666,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   676,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   705,   706,    -1,   708,   709,   113,   114,
      -1,    -1,    -1,    -1,   119,   120,   121,    -1,    -1,    -1,
     125,   126,   127,   725,    -1,   130,   131,   132,   133,   134,
      -1,    -1,    -1,    -1,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,    -1,    -1,    -1,
     155,   156,    -1,    -1,   159,   160,   161,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,   770,   771,
     772,    -1,    -1,   775,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   811,
     812,   813,   814,    -1,   816,   817,   818,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     832,   833,   834,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      -1,   873,    -1,   875,   876,   877,    -1,   879,    -1,    -1,
      -1,   883,    -1,    -1,    -1,    -1,   888,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   901,
      -1,    -1,   904,   905,   906,   907,   908,   909,    -1,   911,
      -1,    -1,    -1,   915,   916,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   953,    -1,   955,    -1,    -1,   958,   959,   960,    -1,
      -1,   963,    -1,    -1,    -1,    -1,   968,   969,   970,   971,
      -1,   973,   974,    -1,    -1,   977,   978,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   997,    -1,    -1,    -1,  1001,
    1002,  1003,  1004,    -1,    -1,    -1,    -1,  1009,    -1,  1011,
    1012,    -1,  1014,    -1,    -1,    -1,    -1,    -1,    -1,   198,
      -1,    -1,   201,    -1,    -1,   204,    -1,    -1,    -1,  1031,
    1032,  1033,  1034,    -1,    -1,  1037,  1038,    -1,  1040,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,
      -1,  1053,  1054,  1055,   233,    -1,    -1,    -1,    -1,   238,
      -1,    -1,    -1,    -1,   243,    -1,    -1,  1069,  1070,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1089,    -1,   268,
     269,   270,   271,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    59,    60,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
     409,   410,    -1,   412,    -1,   414,    84,    -1,    -1,    -1,
      -1,    89,   421,    -1,    -1,    -1,    -1,    -1,   427,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   170,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,    -1,    59,
      60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   567,    -1,
     569,    -1,    -1,   572,   573,    -1,    -1,    -1,    -1,    -1,
      -1,   580,   581,    -1,    84,    -1,   585,    -1,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,    -1,    -1,    -1,   119,
     120,   121,    -1,    -1,    -1,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,    -1,    -1,    -1,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,    -1,    -1,    -1,   155,   156,    -1,    -1,   159,
     160,   161,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,   682,   683,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,   113,   114,    41,    -1,    -1,    -1,   119,   120,   121,
      -1,   790,   791,   125,   126,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,    -1,    -1,    -1,   139,   140,   141,
     142,   810,   144,   145,   146,   147,   148,   149,   150,   151,
      -1,    -1,    -1,   155,   156,    -1,    -1,   159,   160,   161,
     829,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,    -1,    -1,   115,   116,   117,
     118,   193,   194,    -1,   122,   123,   124,    -1,    -1,    -1,
     128,   129,    -1,    -1,    -1,    -1,    -1,   135,   136,   137,
     138,    -1,    -1,    -1,    -1,   143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   152,   153,   154,    -1,    -1,   157,
     158,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,   186,   187,
     188,   189,   190,   191,   192
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    89,   196,   199,   200,     0,    89,    14,   197,   208,
     166,   200,    61,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    42,    43,    44,    57,    59,    84,    98,   113,
     114,   119,   120,   121,   125,   126,   127,   130,   131,   132,
     133,   134,   139,   140,   141,   142,   144,   145,   146,   147,
     148,   149,   150,   151,   155,   156,   159,   160,   161,   193,
     194,   198,   201,   202,   203,   206,   207,   209,   210,   211,
     212,   213,   214,   216,   217,   218,   221,   222,   223,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   254,   255,   256,   257,   258,   259,   260,   262,
     263,   264,   265,   268,   269,   270,   271,   273,   274,   276,
     277,   279,   280,   281,   282,   283,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   317,
     318,   319,   320,   321,   322,   323,   324,   326,   166,    85,
      85,    88,   205,    88,   205,    85,    85,   205,    85,    85,
      57,   373,    37,    38,    39,    40,    56,    57,    69,    74,
      75,    85,    86,    87,   164,   165,   166,   167,   168,   169,
     330,   337,   342,   358,   359,   360,   361,   362,   366,   375,
     376,   388,   389,   337,    75,   327,   373,    51,   331,   373,
      92,   325,    91,    61,   372,    93,    93,    57,   344,   375,
      57,   345,   205,   373,   373,   373,    88,   166,   330,   338,
     342,   359,    97,    97,    93,    93,    85,    85,    93,   183,
     184,   298,    36,   329,   199,   200,     1,   200,    30,    31,
      32,    33,    34,    35,    41,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   115,
     116,   117,   118,   122,   123,   124,   128,   129,   135,   136,
     137,   138,   143,   152,   153,   154,   157,   158,   162,   170,
     185,   186,   187,   188,   189,   190,   191,   192,    22,    23,
      24,    25,    26,    18,   219,   219,    67,    21,   220,   166,
     374,   375,    86,   348,   349,   376,   369,   375,    69,   166,
     167,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   167,   360,   361,   388,   388,   388,    47,
      48,    47,    48,    49,    57,    85,   366,   375,   337,    52,
     364,   365,    57,   367,    45,    50,   391,   368,   375,   332,
     352,   370,   375,   373,   337,   373,   367,   166,   373,    57,
     371,    94,   166,   375,   348,   337,   375,   334,   353,   354,
     366,   375,   337,   333,   347,   353,   375,   368,   373,   373,
     375,   181,   373,   201,    60,   198,   204,   373,   372,   372,
     372,   372,   373,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   373,    61,    93,
      93,     4,    93,    61,    93,     4,     4,   373,   373,   373,
     373,   329,    29,   272,   272,   272,    90,   278,   373,   373,
      61,   183,   184,   183,   183,   183,   184,   183,   183,   183,
     184,   184,    46,    19,    19,    19,    19,   377,    17,   220,
     229,   220,    88,   377,   377,   229,    58,    62,    61,   348,
      61,   350,    55,    62,    57,    58,    71,    76,    72,    73,
      79,    80,    52,    53,    77,    78,    68,    69,    81,    82,
      83,    65,    66,    70,    85,   365,   367,   377,   384,    47,
      48,    49,   390,   391,   377,    52,   364,   163,   328,    71,
     340,   341,   342,   355,   356,   357,   370,   375,    57,   334,
     368,   375,   348,   375,   375,   325,   166,   375,   375,    62,
     348,   348,    62,   348,    52,   363,   363,   367,    57,   346,
     375,   337,   346,   375,    57,   337,   375,   375,   375,   182,
     333,   200,   167,   372,   372,   372,   372,   167,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   334,   166,   373,   373,    61,   284,   373,   166,
     373,    61,   261,   261,   205,   337,    85,   373,    27,   266,
      93,    93,   373,   166,   205,   166,   171,   299,   299,   299,
     299,   299,   299,   299,   299,   299,   299,    86,   314,   348,
     375,   376,    19,   377,   377,   377,   377,    59,   229,   374,
     166,   348,    57,   166,   377,   377,   380,   379,   381,   382,
     383,   383,   384,   384,   384,   384,   387,   387,   386,   386,
     386,   388,   388,   388,    58,   390,   364,    62,    63,    53,
      62,   377,    58,   375,   339,   342,   355,   359,    54,    57,
     377,   337,   337,   337,   166,   253,   337,   375,    58,   348,
     375,   375,   166,   348,   348,   337,   348,   384,   390,   363,
      62,    85,   316,    57,    57,   377,   348,   348,   337,   338,
     204,   166,   372,   372,   372,   372,   166,   334,   334,   368,
     334,   368,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   334,   334,   334,    61,   337,   337,   166,   373,   375,
     373,   375,   166,   373,   373,   166,   166,   332,   334,   375,
      28,   267,   373,   373,   375,   166,   373,   171,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   177,   178,
     179,   307,   308,   377,   229,   229,    20,   215,   215,    85,
     227,   228,    58,   343,   375,   377,    55,    58,    64,   166,
     377,   377,   377,   377,    58,   337,   337,   348,   337,   337,
     337,   348,   348,   337,    58,   348,    62,   348,    53,   316,
     316,    58,   377,   377,    58,   348,   337,   166,   373,   373,
     372,   372,   166,   337,   337,   368,   337,   368,   337,   337,
     337,   337,   337,   337,   337,   337,   337,   337,   337,   337,
     166,   348,   348,   348,   348,   375,   337,   375,   375,   166,
     166,   335,   336,   337,   355,   357,   335,   368,   375,    93,
     337,   337,   275,   348,   375,   312,   314,   312,   312,   313,
     314,   176,   180,   300,   306,   307,   303,   307,   300,   301,
     306,   176,   302,   312,   312,    57,    16,   224,   225,    85,
     229,   229,    67,    60,    62,   367,    58,   378,    53,    62,
      58,    55,    52,   337,   348,   348,   348,   348,   337,   348,
     337,    58,   337,   338,   338,   338,   373,   373,   338,   337,
     337,   368,   337,   337,   337,   337,   337,   337,   337,   337,
     337,   373,   348,   348,   348,   348,   337,   348,   348,   348,
     373,   375,   375,   338,   348,   348,   348,   300,   173,   174,
     303,   301,   302,   175,   312,    54,   312,    54,   312,    54,
      54,   313,   300,   303,   309,   310,   311,   375,   377,     1,
       3,    85,   377,    15,   226,    88,   384,   227,   384,   384,
     348,   348,   348,   348,   337,   348,    58,   337,   348,   338,
     338,   338,   338,   348,   337,   337,   337,   337,   348,   348,
     348,   348,   348,   348,   348,   337,   348,   375,   348,   348,
     305,   387,   315,   349,   376,   305,   311,   314,   314,    58,
      57,    61,    52,   229,    53,    53,   348,   337,   348,   337,
     348,   348,   348,   338,   338,   348,   337,   348,   348,   348,
     348,   348,   348,   375,   351,   348,   348,   315,    70,    55,
      62,   315,    62,   314,   314,   377,   166,     1,   375,   348,
     337,   348,   348,   348,   348,   348,   348,   348,   375,   348,
     351,    68,    69,   304,   172,   315,   304,   309,    62,    62,
     337,   348,   348,   348,   348,   348,   348,   386,   389,    55,
      55,    62,    62,    62,   377,   384,    96,   348,   348,   348,
     351,   172,   172,   315,   309,   309,    58,    53,   337,   348,
      55,    62,    55,    62,    95,   172,   315,   172,   309,   337,
      55,    62,   348,   172,   309,    62,   309,    55
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   195,   196,   197,   198,   198,   199,   199,   200,   200,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   202,   202,   202,   203,   204,   205,   205,   206,   207,
     208,   209,   209,   209,   209,   209,   209,   210,   211,   212,
     213,   214,   215,   215,   216,   217,   217,   218,   218,   219,
     219,   220,   221,   222,   222,   222,   222,   223,   224,   224,
     225,   225,   225,   225,   226,   226,   226,   227,   227,   227,
     228,   228,   229,   229,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   231,   232,   232,   232,   232,   233,
     233,   234,   235,   236,   237,   238,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   249,   249,
     250,   250,   250,   251,   251,   252,   252,   253,   254,   255,
     256,   257,   258,   258,   258,   258,   258,   259,   260,   261,
     261,   262,   263,   263,   264,   265,   266,   266,   267,   267,
     268,   269,   270,   271,   272,   272,   273,   274,   275,   275,
     275,   276,   277,   278,   278,   279,   280,   281,   281,   281,
     282,   283,   283,   283,   283,   283,   284,   284,   285,   285,
     285,   285,   285,   285,   285,   285,   285,   285,   285,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   298,   299,   299,   299,   300,   301,   301,
     302,   303,   303,   303,   303,   304,   304,   304,   305,   305,
     306,   306,   306,   306,   307,   308,   308,   308,   309,   309,
     310,   311,   311,   311,   312,   312,   313,   314,   314,   315,
     315,   316,   316,   316,   317,   317,   317,   317,   317,   317,
     317,   318,   319,   320,   320,   321,   322,   323,   323,   323,
     323,   324,   324,   324,   324,   324,   324,   324,   324,   325,
     325,   326,   326,   327,   327,   328,   328,   329,   329,   330,
     330,   330,   330,   331,   331,   332,   333,   334,   334,   335,
     335,   336,   336,   337,   337,   337,   338,   338,   339,   339,
     339,   340,   340,   341,   341,   342,   343,   344,   345,   346,
     347,   348,   348,   349,   350,   350,   351,   351,   352,   353,
     353,   354,   355,   355,   356,   357,   358,   358,   359,   359,
     359,   359,   359,   359,   360,   360,   360,   361,   361,   361,
     362,   362,   363,   364,   365,   365,   365,   366,   366,   367,
     368,   369,   370,   371,   371,   372,   373,   373,   374,   375,
     375,   376,   376,   377,   378,   378,   379,   379,   380,   380,
     381,   381,   382,   382,   382,   383,   383,   383,   383,   383,
     384,   385,   385,   385,   385,   386,   386,   386,   387,   387,
     387,   387,   388,   388,   388,   388,   389,   389,   389,   389,
     389,   389,   390,   390,   390,   390,   391,   391
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     7,     7,     8,     9,     6,
       6,     6,     7,     6,     7,     8,     7,     6,     8,     8,
       5,     6,     5,     4,     7,     7,     7,     6,     6,     6,
       4,     4,     4,     6,     6,     8,     7,     1,     8,    10,
       8,     9,     1,     1,     1,     3,     2,    10,    13,     0,
       2,    10,     9,     8,     1,    12,     0,     1,     0,     1,
       1,     9,     1,    10,     0,     1,     6,     5,     0,     2,
       2,     1,     6,     0,     1,     9,    16,     9,     5,     6,
       6,     4,     9,     9,     7,     7,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       7,     7,     7,     7,     7,     7,     9,     7,     7,     9,
       5,     4,     1,     1,     0,     1,     2,     7,     9,     1,
      14,     5,     7,     9,    11,     0,     2,     2,     0,     2,
       0,     1,     1,     1,     4,     1,     1,     1,     1,     1,
       1,     1,     3,     6,     2,     2,     2,     1,     1,     1,
       1,     0,     2,     2,     4,     4,     3,     6,     6,     6,
       3,     2,     2,     9,     9,     2,     2,    12,    12,    11,
      11,     1,     2,     1,     1,     2,     1,     2,     1,     0,
       1,     0,     5,     0,     1,     0,     1,     0,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     5,     7,     4,
       4,     1,     3,     2,     2,     4,     0,     2,     1,     3,
       2,     3,     1,     4,     2,     1,     3,     4,     2,     2,
       1,     2,     1,     2,     1,     2,     2,     1,     2,     2,
       3,     4,     3,     7,     1,     5,     3,     5,     3,     5,
       1,     4,     7,     0,     3,     2,     3,     5,     1,     1,
       1,     1,     1,     1,     5,     1,     3,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       3,     1,     2,     2,     2,     1,     1,     1,     3,     2,
       4,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 618 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3006 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 648 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3014 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 652 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3023 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 656 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3029 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 667 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3038 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 675 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3047 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 683 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3055 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 697 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3063 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 704 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3073 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 712 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3083 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 720 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3092 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 727 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3100 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 730 "CISA.y"
                    {(yyval.string) = "";}
#line 3106 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 730 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3112 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 734 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3121 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 742 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3129 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 747 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3140 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 759 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3149 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 766 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3160 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 773 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3166 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 773 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3172 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 774 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3178 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveParameter: DIRECTIVE_PARAMETER IDENT InputSize GenAttrOpt  */
#line 781 "CISA.y"
                                                   {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3186 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 787 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3194 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 791 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3202 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 795 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3210 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 799 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3218 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 805 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3226 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* AlignAttrOpt: %empty  */
#line 810 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3232 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 812 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3240 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IDENT  */
#line 816 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3250 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ IntExp  */
#line 822 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3262 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* Align: ALIGN_EQ error  */
#line 830 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3270 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: %empty  */
#line 837 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3279 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 842 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3288 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 847 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3296 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 853 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3304 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 857 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3312 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* OneAttr: IDENT  */
#line 861 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3320 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 867 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3328 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* AttrOpt: OneAttr  */
#line 872 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3336 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: %empty  */
#line 878 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3344 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 73: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 882 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3352 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 124: /* Label: LABEL  */
#line 943 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3358 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 948 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3367 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 954 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3375 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 959 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3384 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 965 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3393 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 973 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3402 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 979 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3411 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 986 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3420 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 993 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3429 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1000 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3438 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1007 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3450 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1019 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3459 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1026 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3468 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1035 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3479 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1045 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3488 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1051 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3497 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1058 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3505 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1064 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3514 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1073 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3526 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1083 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3535 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1090 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3544 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1097 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3553 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1105 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3563 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1114 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3573 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1121 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3583 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1128 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3591 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1134 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3600 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1140 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3609 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1146 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3618 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1164 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3627 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1171 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3638 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1181 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3648 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1189 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3658 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1195 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3667 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1203 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3677 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1212 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3687 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1221 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3697 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1230 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3707 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* SynchronizationInstruction: BARRIER_OP  */
#line 1237 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3715 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1240 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3723 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1243 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3731 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1246 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3739 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1249 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3747 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1255 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3756 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1262 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3766 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* Atomic16Opt: %empty  */
#line 1269 "CISA.y"
             {(yyval.flag) = false;}
#line 3772 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* Atomic16Opt: DOT DEC_LIT  */
#line 1270 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3781 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1277 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3791 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1286 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3801 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1294 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3811 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* Sample3DInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1306 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3824 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* CPSEnableOpt: %empty  */
#line 1318 "CISA.y"
                     {(yyval.cps) = false;}
#line 3830 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* CPSEnableOpt: CPS  */
#line 1318 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3836 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* NonUniformSamplerEnableOpt: %empty  */
#line 1320 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3842 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1320 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3848 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* Load3DInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1328 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3861 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* Gather43DInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1344 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3874 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* PixelNullMaskEnableOpt: %empty  */
#line 1354 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3880 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1354 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3886 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1358 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3896 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1366 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3906 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* RTWriteOperands: %empty  */
#line 1374 "CISA.y"
    {
    }
#line 3913 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1377 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3921 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1381 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 3929 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1390 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3942 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* RTWriteModeOpt: %empty  */
#line 1400 "CISA.y"
                       {(yyval.string) = 0;}
#line 3948 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1405 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3958 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1413 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3970 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1425 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3988 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1441 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3996 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1447 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4011 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1460 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4020 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1468 "CISA.y"
    {
        bool aligned = false;
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).exec_size, aligned,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4030 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1475 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4039 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1481 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4048 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1487 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4057 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1493 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4066 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* AtomicBitwidthOpt: %empty  */
#line 1499 "CISA.y"
             {(yyval.intval) = 32;}
#line 4072 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1500 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4081 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 220: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1550 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4105 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 221: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1581 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4129 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 222: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1610 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            CISAlineno);
    }
#line 4150 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 223: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1635 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4174 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1659 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4198 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1686 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            CISAlineno);
    }
#line 4219 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1712 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,     // address info
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addr
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4243 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand  */
#line 1746 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr.type,  // address model
            (yyvsp[0].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-1].lsc_data_operand).shape,    // data type
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[0].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[0].lsc_addr_operand).regs[3],  // src0_lod
            nullptr,     // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4274 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperand LscDataOperand  */
#line 1786 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr.type,  // address model
            (yyvsp[-1].lsc_addr_operand).addr.size,  // address size
            (yyvsp[0].lsc_data_operand).shape,    // data type
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[-1].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[-1].lsc_addr_operand).regs[3],  // src0_lod
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4305 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1826 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr.type, // address model
            (yyvsp[-2].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_addr_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_addr_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_addr_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4333 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscRegAddrModel  */
#line 1857 "CISA.y"
   {
        LSC_CACHE_OPTS caching{LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape{LSC_DATA_SIZE_32b,LSC_DATA_ORDER_NONTRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_1;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-4].pred_reg),              // predicate
            (yyvsp[-3].lsc_subOpcode),              // subop
            (yyvsp[-2].lsc_sfid),              // sfid
            caching,         // caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[0].lsc_addr_model).type,           // address model
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[0].lsc_addr_model).surface,        // surface
            (yyvsp[-1].RawVar),                // dst data
            nullptr,           // src0 addrs u
            nullptr,           // src0 addrs v
            nullptr,           // src0 addrs r
            nullptr,           // src0 addrs lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
   }
#line 4362 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 1890 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4370 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscCacheOpts: %empty  */
#line 1897 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};}
#line 4376 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscCacheOpts: LSC_CACHING_OPT  */
#line 1898 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[0].lsc_caching_opt),LSC_CACHING_DEFAULT};}
#line 4382 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 1899 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt)};}
#line 4388 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 1906 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-3].RawVar)},{(yyvsp[-6].lsc_addr_model).type,(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4396 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm RBRACK LSC_ADDR_SIZE_TK  */
#line 1915 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-5].RawVar),(yyvsp[-2].lsc_addr_surface_ident)},{(yyvsp[-8].lsc_addr_model).type,(int)(yyvsp[-6].intval),(int)(yyvsp[-4].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4404 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 1918 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4413 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm RBRACK  */
#line 1941 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {nullptr,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4421 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1954 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-4].lsc_addr_model).surface,{(yyvsp[-2].RawVar)},{(yyvsp[-4].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4429 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1965 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-6].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4437 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1976 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-8].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4445 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1987 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar),(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4453 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscAddrImmOffsetOpt: %empty  */
#line 1995 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4459 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 1996 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4465 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscAddrImmOffsetOpt: MINUS IntExpPrim  */
#line 1997 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4471 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscAddrImmScaleOpt: %empty  */
#line 2004 "CISA.y"
                      {(yyval.intval) = 1;}
#line 4477 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscAddrImmScaleOpt: IntExpMul TIMES  */
#line 2005 "CISA.y"
                      {(yyval.intval) = (yyvsp[-1].intval);}
#line 4483 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscAddrModelOpt: %empty  */
#line 2008 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4489 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2009 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4495 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2010 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG,nullptr};}
#line 4501 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscRegAddrModel: LscRegAddrModelKind LPAREN LscVectorOpRegOrImm RPAREN  */
#line 2015 "CISA.y"
                                                             {
        (yyval.lsc_addr_model) = {(yyvsp[-3].lsc_addr_type),(yyvsp[-1].lsc_addr_surface_ident)};
    }
#line 4509 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscRegAddrModelKind: LSC_AM_BSS  */
#line 2020 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BSS;}
#line 4515 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscRegAddrModelKind: LSC_AM_SS  */
#line 2021 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_SS;}
#line 4521 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscRegAddrModelKind: LSC_AM_BTI  */
#line 2022 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BTI;}
#line 4527 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscVectorOpImm: IntExp  */
#line 2027 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval),ISA_TYPE_UD, CISAlineno);
    }
#line 4535 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscVectorOpReg: Var  */
#line 2032 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4547 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2040 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4559 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2048 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4576 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2062 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4584 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2066 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4592 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2072 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4600 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* LscPayloadReg: Var  */
#line 2080 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4608 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* LscPayloadNonNullReg: VarNonNull  */
#line 2087 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4616 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* SwitchLabels: %empty  */
#line 2093 "CISA.y"
    {
    }
#line 4623 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* SwitchLabels: COMMA SwitchLabels  */
#line 2096 "CISA.y"
    {
    }
#line 4630 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* SwitchLabels: IDENT SwitchLabels  */
#line 2099 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 4639 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2106 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 4647 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2110 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 4655 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2114 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 4663 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2118 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 4672 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 278: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2124 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4680 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2129 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4690 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2136 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4698 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* FILE: FILE_OP STRING_LIT  */
#line 2141 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 4706 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* LOC: LOC_OP DEC_LIT  */
#line 2146 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4714 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2152 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4723 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2159 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4732 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2166 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 4740 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2172 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 4748 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2178 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4759 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2186 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4770 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2194 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4781 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2202 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4792 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2211 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4800 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2216 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4808 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* NullaryInstruction: YIELD_OP  */
#line 2221 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4816 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2226 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 4824 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2231 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 4832 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2236 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 4840 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2241 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 4848 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* NullaryInstruction: FENCE_SW_OP  */
#line 2246 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 4856 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* OwordModifier: %empty  */
#line 2250 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 4862 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* Predicate: %empty  */
#line 2257 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 4870 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2262 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 4878 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* PredSign: %empty  */
#line 2266 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 4884 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* PredSign: BANG  */
#line 2266 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 4890 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* PredCtrlOpt: %empty  */
#line 2268 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 4896 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* SatModOpt: %empty  */
#line 2271 "CISA.y"
                  {(yyval.sat) = false;}
#line 4902 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* SatModOpt: SAT  */
#line 2271 "CISA.y"
                                      {(yyval.sat) = true;}
#line 4908 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* SrcModifier: SRCMOD_NEG  */
#line 2274 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 4914 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* SrcModifier: SRCMOD_ABS  */
#line 2275 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 4920 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* SrcModifier: SRCMOD_NEGABS  */
#line 2276 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 4926 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* SrcModifier: SRCMOD_NOT  */
#line 2277 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 4932 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* ConditionalModifier: %empty  */
#line 2279 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 4938 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* VecDstOperand_A: DstAddrOperand  */
#line 2284 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4944 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* VecDstOperand_G: DstGeneralOperand  */
#line 2285 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4950 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2287 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4956 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 318: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2288 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4962 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2293 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4968 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2297 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4974 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2301 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4980 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2302 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4986 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2306 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4992 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2310 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4998 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 330: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2311 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5004 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2315 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5010 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2319 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5016 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2321 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5022 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2324 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5034 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2334 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5043 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 338: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2341 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5053 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2349 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5063 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 340: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2357 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5073 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2388 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5082 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2395 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5090 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2406 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5099 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2411 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5108 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* RawOperandArray: %empty  */
#line 2419 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5116 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2424 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5125 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2432 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5135 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2440 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5144 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* DstGeneralOperand: Var DstRegion  */
#line 2445 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5153 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2451 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5162 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* SrcAddrOfOperand: AddrOfVar  */
#line 2472 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5170 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2476 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5179 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* AddrOfVar: AMP Var  */
#line 2482 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5192 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2493 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5202 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2501 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5212 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2508 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5222 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2518 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5230 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2523 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5240 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* SrcImmOperand: FloatLit  */
#line 2531 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5248 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* SrcImmOperand: MINUS FloatLit  */
#line 2534 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5256 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* SrcImmOperand: DoubleFloatLit  */
#line 2540 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5264 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2544 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5272 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* FloatLit: DEC_LIT FTYPE  */
#line 2551 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5283 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* FloatLit: HEX_LIT FTYPE  */
#line 2558 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5293 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2566 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5304 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2572 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5315 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2583 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5326 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2591 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5337 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2600 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5347 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2618 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5363 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2635 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5377 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2646 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5389 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2656 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5398 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2661 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5407 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2666 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5418 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* PredVar: Var  */
#line 2674 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5430 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2683 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5445 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2695 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5460 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* SIMDMode: %empty  */
#line 2709 "CISA.y"
           {(yyval.intval) = 0;}
#line 5466 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 2712 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5476 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* ElemNum: DOT DEC_LIT  */
#line 2723 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5484 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 2735 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5493 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 2741 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5504 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 388: /* ExecSizeInt: DEC_LIT  */
#line 2749 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5515 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2763 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5521 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2766 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5527 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 398: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2769 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5533 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 400: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2772 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5539 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 402: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2775 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5545 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 403: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2776 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5551 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2779 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5557 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2780 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5563 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 407: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2781 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5569 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 408: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2782 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5575 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 411: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2803 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5581 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2804 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5587 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 413: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2805 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5593 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2808 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5599 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 416: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2809 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5605 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 418: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2812 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5611 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 419: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2813 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5621 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 420: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2818 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 5631 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 422: /* IntExpUnr: MINUS IntExpUnr  */
#line 2825 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 5637 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 423: /* IntExpUnr: TILDE IntExpUnr  */
#line 2826 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 5643 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 424: /* IntExpUnr: BANG IntExpUnr  */
#line 2827 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 5649 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2835 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 5655 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 429: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2839 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 5664 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 430: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2843 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 5674 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 431: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2849 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 5685 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 5689 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13463.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2867 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
